yi-keymap-vim-0.19.0: Vim keymap for Yi editor

License | GPL-2
Maintainer | yi-devel@googlegroups.com
Stability | experimental
Portability | portable
Safe Haskell | None
Language | Haskell2010

Extensions

- Cpp
- TemplateHaskell
- TemplateHaskellQuotes
- DeriveDataTypeable
- DeriveGeneric
- GeneralizedNewtypeDeriving

Yi.Keymap.Vim.Common

Description

Common types used by the vim keymap.

# Documentation

data VimMode Source #

Constructors

Normal |
NormalOperatorPending OperatorName |
Insert Char | char denotes how state got into insert mode (`i`, `a`, etc.)
Replace |
ReplaceSingleChar |
InsertNormal | after C-o
InsertVisual | after C-o and one of v, V, C-v
Visual RegionStyle |
Ex |
Search |

Fields

- previousMode :: VimMode
- direction :: Direction

#### Instances

Instances details

Binary VimMode Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods put :: VimMode -> Put Source # get :: Get VimMode Source # putList :: [VimMode] -> Put Source #
Default VimMode Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods def :: VimMode Source #
Generic VimMode Source # |

Instance details

Defined in Yi.Keymap.Vim.Common

Associated Types

type Rep VimMode |

Instance details

Defined in Yi.Keymap.Vim.Common

type Rep VimMode = D1 ('MetaData "VimMode" "Yi.Keymap.Vim.Common" "yi-keymap-vim-0.19.0-fQG0LI2vTD5pZqqSZy2CX" 'False) (((C1 ('MetaCons "Normal" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "NormalOperatorPending" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 OperatorName))) :+: (C1 ('MetaCons "Insert" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Char)) :+: (C1 ('MetaCons "Replace" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "ReplaceSingleChar" 'PrefixI 'False) (U1 :: Type -> Type)))) :+: ((C1 ('MetaCons "InsertNormal" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "InsertVisual" 'PrefixI 'False) (U1 :: Type -> Type)) :+: (C1 ('MetaCons "Visual" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 RegionStyle)) :+: (C1 ('MetaCons "Ex" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "Search" 'PrefixI 'True) (S1 ('MetaSel ('Just "previousMode") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 VimMode) :*: S1 ('MetaSel ('Just "direction") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Direction))))))

Methods

from :: VimMode -> Rep VimMode x Source #

to :: Rep VimMode x -> VimMode Source #

Show VimMode Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods showsPrec :: Int -> VimMode -> ShowS Source # show :: VimMode -> String Source # showList :: [VimMode] -> ShowS Source #
Eq VimMode Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods (==) :: VimMode -> VimMode -> Bool Source # (/=) :: VimMode -> VimMode -> Bool Source #
type Rep VimMode Source # |

Instance details

Defined in Yi.Keymap.Vim.Common

type Rep VimMode = D1 ('MetaData "VimMode" "Yi.Keymap.Vim.Common" "yi-keymap-vim-0.19.0-fQG0LI2vTD5pZqqSZy2CX" 'False) (((C1 ('MetaCons "Normal" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "NormalOperatorPending" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 OperatorName))) :+: (C1 ('MetaCons "Insert" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Char)) :+: (C1 ('MetaCons "Replace" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "ReplaceSingleChar" 'PrefixI 'False) (U1 :: Type -> Type)))) :+: ((C1 ('MetaCons "InsertNormal" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "InsertVisual" 'PrefixI 'False) (U1 :: Type -> Type)) :+: (C1 ('MetaCons "Visual" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 RegionStyle)) :+: (C1 ('MetaCons "Ex" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "Search" 'PrefixI 'True) (S1 ('MetaSel ('Just "previousMode") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 VimMode) :*: S1 ('MetaSel ('Just "direction") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Direction))))))

data VimBinding Source #

Constructors

VimBindingY (EventString -> VimState -> MatchResult (YiM RepeatToken)) |
VimBindingE (EventString -> VimState -> MatchResult (EditorM RepeatToken)) |

data GotoCharCommand Source #

Constructors

GotoCharCommand !Char !Direction !RegionStyle |

#### Instances

Instances details

Binary GotoCharCommand Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods put :: GotoCharCommand -> Put Source # get :: Get GotoCharCommand Source # putList :: [GotoCharCommand] -> Put Source #
Generic GotoCharCommand Source # |

Instance details

Defined in Yi.Keymap.Vim.Common

Associated Types

type Rep GotoCharCommand |

Instance details

Defined in Yi.Keymap.Vim.Common

type Rep GotoCharCommand = D1 ('MetaData "GotoCharCommand" "Yi.Keymap.Vim.Common" "yi-keymap-vim-0.19.0-fQG0LI2vTD5pZqqSZy2CX" 'False) (C1 ('MetaCons "GotoCharCommand" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Char) :*: (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Direction) :*: S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 RegionStyle))))

Methods

from :: GotoCharCommand -> Rep GotoCharCommand x Source #

to :: Rep GotoCharCommand x -> GotoCharCommand Source #

type Rep GotoCharCommand Source # |

Instance details

Defined in Yi.Keymap.Vim.Common

type Rep GotoCharCommand = D1 ('MetaData "GotoCharCommand" "Yi.Keymap.Vim.Common" "yi-keymap-vim-0.19.0-fQG0LI2vTD5pZqqSZy2CX" 'False) (C1 ('MetaCons "GotoCharCommand" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Char) :*: (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Direction) :*: S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 RegionStyle))))

data VimState Source #

Constructors

VimState |

Fields

- vsMode :: !VimMode
- vsCount :: !(Maybe Int)
- vsAccumulator :: !EventString

  for repeat and potentially macros

- vsTextObjectAccumulator :: !EventString
- vsRegisterMap :: !(HashMap RegisterName Register)
- vsActiveRegister :: !RegisterName
- vsRepeatableAction :: !(Maybe RepeatableAction)
- vsStringToEval :: !EventString

  see Yi.Keymap.Vim.pureEval comment

- vsOngoingInsertEvents :: !EventString
- vsLastGotoCharCommand :: !(Maybe GotoCharCommand)
- vsBindingAccumulator :: !EventString
- vsSecondaryCursors :: ![Point]
- vsPaste :: !Bool

  like vim's :help paste

- vsCurrentMacroRecording :: !(Maybe (MacroName, EventString))
- vsLastSubstitution :: !(Maybe Substitution)

#### Instances

Instances details

Binary VimState Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods put :: VimState -> Put Source # get :: Get VimState Source # putList :: [VimState] -> Put Source #
Default VimState Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods def :: VimState Source #
Generic VimState Source # |

Instance details

Defined in Yi.Keymap.Vim.Common

Associated Types

type Rep VimState |
Instance details Defined in Yi.Keymap.Vim.Common type Rep VimState

Methods

from :: VimState -> Rep VimState x Source #

to :: Rep VimState x -> VimState Source #

YiVariable VimState Source # |
Instance details Defined in Yi.Keymap.Vim.Common
type Rep VimState Source # |
Instance details Defined in Yi.Keymap.Vim.Common type Rep VimState

data Register Source #

Constructors

Register |

Fields

- regRegionStyle :: RegionStyle
- regContent :: YiString

#### Instances

Instances details

Binary Register Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods put :: Register -> Put Source # get :: Get Register Source # putList :: [Register] -> Put Source #
Generic Register Source # |

Instance details

Defined in Yi.Keymap.Vim.Common

Associated Types

type Rep Register |

Instance details

Defined in Yi.Keymap.Vim.Common

type Rep Register = D1 ('MetaData "Register" "Yi.Keymap.Vim.Common" "yi-keymap-vim-0.19.0-fQG0LI2vTD5pZqqSZy2CX" 'False) (C1 ('MetaCons "Register" 'PrefixI 'True) (S1 ('MetaSel ('Just "regRegionStyle") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 RegionStyle) :*: S1 ('MetaSel ('Just "regContent") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 YiString)))

Methods

from :: Register -> Rep Register x Source #

to :: Rep Register x -> Register Source #

Show Register Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods showsPrec :: Int -> Register -> ShowS Source # show :: Register -> String Source # showList :: [Register] -> ShowS Source #
type Rep Register Source # |

Instance details

Defined in Yi.Keymap.Vim.Common

type Rep Register = D1 ('MetaData "Register" "Yi.Keymap.Vim.Common" "yi-keymap-vim-0.19.0-fQG0LI2vTD5pZqqSZy2CX" 'False) (C1 ('MetaCons "Register" 'PrefixI 'True) (S1 ('MetaSel ('Just "regRegionStyle") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 RegionStyle) :*: S1 ('MetaSel ('Just "regContent") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 YiString)))

data RepeatToken Source #

Constructors

Finish |
Drop |
Continue |

#### Instances

Instances details

Show RepeatToken Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods showsPrec :: Int -> RepeatToken -> ShowS Source # show :: RepeatToken -> String Source # showList :: [RepeatToken] -> ShowS Source #

data RepeatableAction Source #

Constructors

RepeatableAction |

Fields

- raPreviousCount :: !Int
- raActionString :: !EventString

#### Instances

Instances details

Binary RepeatableAction Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods put :: RepeatableAction -> Put Source # get :: Get RepeatableAction Source # putList :: [RepeatableAction] -> Put Source #
Generic RepeatableAction Source # |

Instance details

Defined in Yi.Keymap.Vim.Common

Associated Types

type Rep RepeatableAction |

Instance details

Defined in Yi.Keymap.Vim.Common

type Rep RepeatableAction = D1 ('MetaData "RepeatableAction" "Yi.Keymap.Vim.Common" "yi-keymap-vim-0.19.0-fQG0LI2vTD5pZqqSZy2CX" 'False) (C1 ('MetaCons "RepeatableAction" 'PrefixI 'True) (S1 ('MetaSel ('Just "raPreviousCount") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Int) :*: S1 ('MetaSel ('Just "raActionString") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 EventString)))

Methods

from :: RepeatableAction -> Rep RepeatableAction x Source #

to :: Rep RepeatableAction x -> RepeatableAction Source #

Show RepeatableAction Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods showsPrec :: Int -> RepeatableAction -> ShowS Source # show :: RepeatableAction -> String Source # showList :: [RepeatableAction] -> ShowS Source #
Eq RepeatableAction Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods (==) :: RepeatableAction -> RepeatableAction -> Bool Source # (/=) :: RepeatableAction -> RepeatableAction -> Bool Source #
type Rep RepeatableAction Source # |

Instance details

Defined in Yi.Keymap.Vim.Common

type Rep RepeatableAction = D1 ('MetaData "RepeatableAction" "Yi.Keymap.Vim.Common" "yi-keymap-vim-0.19.0-fQG0LI2vTD5pZqqSZy2CX" 'False) (C1 ('MetaCons "RepeatableAction" 'PrefixI 'True) (S1 ('MetaSel ('Just "raPreviousCount") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Int) :*: S1 ('MetaSel ('Just "raActionString") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 EventString)))

data MatchResult a Source #

Constructors

NoMatch |
PartialMatch |
WholeMatch a |

#### Instances

Instances details

Alternative MatchResult Source # |
Instance details Defined in Yi.Keymap.Vim.MatchResult Methods empty :: MatchResult a Source # (<|>) :: MatchResult a -> MatchResult a -> MatchResult a Source # some :: MatchResult a -> MatchResult [a] Source # many :: MatchResult a -> MatchResult [a] Source #
Applicative MatchResult Source # |
Instance details Defined in Yi.Keymap.Vim.MatchResult Methods pure :: a -> MatchResult a Source # (<*>) :: MatchResult (a -> b) -> MatchResult a -> MatchResult b Source # liftA2 :: (a -> b -> c) -> MatchResult a -> MatchResult b -> MatchResult c Source # (*>) :: MatchResult a -> MatchResult b -> MatchResult b Source # (<*) :: MatchResult a -> MatchResult b -> MatchResult a Source #
Functor MatchResult Source # |
Instance details Defined in Yi.Keymap.Vim.MatchResult Methods fmap :: (a -> b) -> MatchResult a -> MatchResult b Source # (<$) :: a -> MatchResult b -> MatchResult a Source #
Show (MatchResult a) Source # |
Instance details Defined in Yi.Keymap.Vim.MatchResult Methods showsPrec :: Int -> MatchResult a -> ShowS Source # show :: MatchResult a -> String Source # showList :: [MatchResult a] -> ShowS Source #

newtype EventString Source #

Constructors

Ev |

Fields

- _unEv :: Text

#### Instances

Instances details

Binary EventString Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods put :: EventString -> Put Source # get :: Get EventString Source # putList :: [EventString] -> Put Source #
Monoid EventString Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods mempty :: EventString Source # mappend :: EventString -> EventString -> EventString Source # mconcat :: [EventString] -> EventString Source #
Semigroup EventString Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods (<>) :: EventString -> EventString -> EventString Source # sconcat :: NonEmpty EventString -> EventString Source # stimes :: Integral b => b -> EventString -> EventString Source #
IsString EventString Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods fromString :: String -> EventString Source #
Show EventString Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods showsPrec :: Int -> EventString -> ShowS Source # show :: EventString -> String Source # showList :: [EventString] -> ShowS Source #
Eq EventString Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods (==) :: EventString -> EventString -> Bool Source # (/=) :: EventString -> EventString -> Bool Source #
Ord EventString Source # |

Instance details

Defined in Yi.Keymap.Vim.Common

Methods

compare :: EventString -> EventString -> Ordering Source #

(<) :: EventString -> EventString -> Bool Source #

(<=) :: EventString -> EventString -> Bool Source #

(>) :: EventString -> EventString -> Bool Source #

(>=) :: EventString -> EventString -> Bool Source #

max :: EventString -> EventString -> EventString Source #

min :: EventString -> EventString -> EventString Source #

unEv :: Lens' EventString Text Source #

newtype OperatorName Source #

Constructors

Op |

Fields

- _unOp :: Text

#### Instances

Instances details

Binary OperatorName Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods put :: OperatorName -> Put Source # get :: Get OperatorName Source # putList :: [OperatorName] -> Put Source #
Monoid OperatorName Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods mempty :: OperatorName Source # mappend :: OperatorName -> OperatorName -> OperatorName Source # mconcat :: [OperatorName] -> OperatorName Source #
Semigroup OperatorName Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods (<>) :: OperatorName -> OperatorName -> OperatorName Source # sconcat :: NonEmpty OperatorName -> OperatorName Source # stimes :: Integral b => b -> OperatorName -> OperatorName Source #
IsString OperatorName Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods fromString :: String -> OperatorName Source #
Show OperatorName Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods showsPrec :: Int -> OperatorName -> ShowS Source # show :: OperatorName -> String Source # showList :: [OperatorName] -> ShowS Source #
Eq OperatorName Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods (==) :: OperatorName -> OperatorName -> Bool Source # (/=) :: OperatorName -> OperatorName -> Bool Source #

unOp :: Lens' OperatorName Text Source #

type RegisterName = Char Source #

data Substitution Source #

Constructors

Substitution |

Fields

- subsFrom :: YiString
- subsTo :: YiString
- subsFlagGlobal :: !Bool
- subsFlagCaseInsensitive :: !Bool
- subsFlagConfirm :: !Bool

#### Instances

Instances details

Binary Substitution Source # |
Instance details Defined in Yi.Keymap.Vim.Common Methods put :: Substitution -> Put Source # get :: Get Substitution Source # putList :: [Substitution] -> Put Source #
Generic Substitution Source # |

Instance details

Defined in Yi.Keymap.Vim.Common

Associated Types

type Rep Substitution |

Instance details

Defined in Yi.Keymap.Vim.Common

type Rep Substitution = D1 ('MetaData "Substitution" "Yi.Keymap.Vim.Common" "yi-keymap-vim-0.19.0-fQG0LI2vTD5pZqqSZy2CX" 'False) (C1 ('MetaCons "Substitution" 'PrefixI 'True) ((S1 ('MetaSel ('Just "subsFrom") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 YiString) :*: S1 ('MetaSel ('Just "subsTo") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 YiString)) :*: (S1 ('MetaSel ('Just "subsFlagGlobal") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Bool) :*: (S1 ('MetaSel ('Just "subsFlagCaseInsensitive") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Bool) :*: S1 ('MetaSel ('Just "subsFlagConfirm") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Bool)))))

Methods

from :: Substitution -> Rep Substitution x Source #

to :: Rep Substitution x -> Substitution Source #

type Rep Substitution Source # |

Instance details

Defined in Yi.Keymap.Vim.Common

type Rep Substitution = D1 ('MetaData "Substitution" "Yi.Keymap.Vim.Common" "yi-keymap-vim-0.19.0-fQG0LI2vTD5pZqqSZy2CX" 'False) (C1 ('MetaCons "Substitution" 'PrefixI 'True) ((S1 ('MetaSel ('Just "subsFrom") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 YiString) :*: S1 ('MetaSel ('Just "subsTo") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 YiString)) :*: (S1 ('MetaSel ('Just "subsFlagGlobal") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Bool) :*: (S1 ('MetaSel ('Just "subsFlagCaseInsensitive") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Bool) :*: S1 ('MetaSel ('Just "subsFlagConfirm") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Bool)))))

data MatchResult a Source #

Constructors

NoMatch |
PartialMatch |
WholeMatch a |

#### Instances

Instances details

Alternative MatchResult Source # |
Instance details Defined in Yi.Keymap.Vim.MatchResult Methods empty :: MatchResult a Source # (<|>) :: MatchResult a -> MatchResult a -> MatchResult a Source # some :: MatchResult a -> MatchResult [a] Source # many :: MatchResult a -> MatchResult [a] Source #
Applicative MatchResult Source # |
Instance details Defined in Yi.Keymap.Vim.MatchResult Methods pure :: a -> MatchResult a Source # (<*>) :: MatchResult (a -> b) -> MatchResult a -> MatchResult b Source # liftA2 :: (a -> b -> c) -> MatchResult a -> MatchResult b -> MatchResult c Source # (*>) :: MatchResult a -> MatchResult b -> MatchResult b Source # (<*) :: MatchResult a -> MatchResult b -> MatchResult a Source #
Functor MatchResult Source # |
Instance details Defined in Yi.Keymap.Vim.MatchResult Methods fmap :: (a -> b) -> MatchResult a -> MatchResult b Source # (<$) :: a -> MatchResult b -> MatchResult a Source #
Show (MatchResult a) Source # |
Instance details Defined in Yi.Keymap.Vim.MatchResult Methods showsPrec :: Int -> MatchResult a -> ShowS Source # show :: MatchResult a -> String Source # showList :: [MatchResult a] -> ShowS Source #

lookupBestMatch :: EventString -> [(EventString, a)] -> MatchResult a Source #

matchesString :: EventString -> EventString -> MatchResult () Source #